// threading.hpp
// -------------
//
//  (C) Copyright Gerald Thaler 2008.
//
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef INTREPID_THREADING_HPP
#define INTREPID_THREADING_HPP

#if defined(_MSC_VER) && (_MSC_VER >= 1200)
# pragma once
#endif // defined(_MSC_VER) && (_MSC_VER >= 1200)

namespace intrepid
{
    namespace threading
    {
        class high_priority_range
        {
        public:
            high_priority_range();
            ~high_priority_range();

        private:
            high_priority_range(high_priority_range const &); // = delete;
            high_priority_range &operator=(
                                    high_priority_range const &); // = delete;
        };

        void pop_priority();
        void push_high_priority();

// class high_priority_range
// public:

        inline high_priority_range::high_priority_range()
        {
            push_high_priority();
        }

        inline high_priority_range::~high_priority_range()
        {
            pop_priority();
        }

    } // end of namespace threading
} // end of namespace intrepid

#endif // include guard
